Bug 1737929 (SugarOnPy3)

Summary: sugar depends on Python 2
Product: [Fedora] Fedora Reporter: Lumír Balhar <lbalhar>
Component: sugarAssignee: Peter Robinson <pbrobinson>
Status: MODIFIED --- QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: 31CC: aperez, awilliam, ibiamchihurumnaya, john.j5live, pbrobinson, pviktori, satellitgo, simon, smparrish
Target Milestone: ---Keywords: Triaged
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On: 1738975, 1738979, 1738981, 1738991, 1738993, 1738997, 1739000, 1739003, 1739056, 1739061, 1674828, 1701920, 1734179, 1735100, 1736374, 1736722, 1736897, 1736900, 1737983, 1737985, 1737995, 1738086, 1738104, 1738116, 1738169, 1738170, 1738929, 1738940, 1738941, 1738974, 1738976, 1738980, 1738982, 1738983, 1738986, 1738988, 1738992, 1738994, 1738995, 1738996, 1738999, 1739001, 1739002, 1739004, 1739005, 1739006, 1739007, 1739008, 1739009, 1739055, 1739058, 1739062, 1739063, 1739064, 1739066, 1739067, 1739068, 1739069, 1739512, 1739733, 1739914, 1739915, 1747854, 1751488, 1787243, 1787244, 1787255, 1787256, 1787257    
Bug Blocks: 1698500    
Attachments:
Description Flags
install sugar-desktop to Fedora-Mate-armhfp-31-20190824.n.0-sda.raw.xz none

Description Lumír Balhar 2019-08-06 11:40:18 UTC
Python 2.7 will reach end-of-life in January 2020, over 9 years after it was released. This falls within the Fedora 31 lifetime.
Packages that depend on Python 2 are being switched to Python 3 or removed from Fedora: https://fedoraproject.org/wiki/Changes/F31_Mass_Python_2_Package_Removal#Information_on_Remaining_Packages
Python 2 will be retired in Fedora 32: https://fedoraproject.org/wiki/Changes/RetirePython2

To help planning, we'd like to know the plans for sugar's future. Specifically:


- What is the reason for the Python2 dependency? (Is it software written in Python, or does it just provide Python bindings, or use Python in the build system or test runner?) 

- What are the upstream/community plans/timelines regarding Python 3?

- What is the guidance for porting to Python 3? (Assuming that there is someone who generally knows how to port to Python 3, but doesn't know anything about the particular package, what are the next steps to take?)


This bug is filed semi-automatically, and might not have all the context specific to sugar.
If you need anything from us, or something is unclear, please mention it here.

Thank you.

Comment 1 Alex Perez 2019-08-06 23:05:13 UTC
I sit on the Oversight Board for Sugar Labs, as an elected member. Sugar is written in Python, and it makes use of several components/python modules which were never ported to Python 3, such as Telepathy. Sugar was originally written in an era when Python 3 did not exist. 

We are aware of this impending deadline, and have been working to make our codebase compatible with Python 3. Python has no full time programmers, so testing is slow, but work is being done.

Comment 2 Ben Cotton 2019-08-13 16:56:56 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to '31'.

Comment 3 Ben Cotton 2019-08-13 17:35:25 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to 31.

Comment 4 Lumír Balhar 2019-08-15 07:43:36 UTC
The current plan is to remove packages with dependency on Python 2 from Fedora 32 in the middle of November 2019. If you want to keep your package in Fedora after that date and you cannot port it to Python 3 yet, you need to request a FESCo exception for the package and all its Python 2 dependencies (even transitive) [1]. If you don't want to maintain it anymore, please orphan the package.

If you're considering filing the exception request, let us know. We can help (for example, we can help find all the dependencies).

[1] https://fedoraproject.org/wiki/Changes/RetirePython2#FESCo_exceptions

Comment 5 Peter Robinson 2019-08-19 12:19:39 UTC
going to use this as a tracker for sugar UX migration to python3 and link all the other bugs to depend on this so it can be tracked here.

Comment 6 Petr Viktorin 2019-08-19 13:56:09 UTC
I'm sorry for the spam!

We're trying to gather the information on about 1000 packages. We forgot to check that these 80 of them are related, and just need to be asked once :(

We've made a special case for "sugar-*" and "olpc-*" packages. Others (like "hippo-canvas") aren't that easy to catch: if you get more spam, please complain so we can fix it!

Comment 7 Peter Robinson 2019-08-19 13:59:54 UTC
We're looking to deprecate hippo-canvas, it was used in the old gtk2 Activities, there's a few more to migrate to the gtk3. There's overall been a multi year effort to move to python3 including moving from gstreamer 0.10 python bindings to py3 friendly introspection based gst 1.0 bindings etc. There's only a handful of gtk2 based Activities left (repoquery --whatrequires sugar-toolkit)

Comment 8 satellitgo 2019-08-28 03:33:26 UTC
Created attachment 1608780 [details]
install sugar-desktop to Fedora-Mate-armhfp-31-20190824.n.0-sda.raw.xz

branched f31 arm

Comment 9 Petr Viktorin 2019-10-07 15:07:22 UTC
> We are aware of this impending deadline

I don't like to spam again, but the upstream deadline is in less than 3 months and the Fedora deadline is in little more than a month. I haven't seen much activity on the Fedora side, which makes me worry.

Is everything on track?
Do you need help getting an exception to keep Sugar on Python 2 in Fedora 32, to get some more time?
As it is, the maintainers of packages like python2-numpy, python2-pygame, python2-pytest, python2-simplejson etc. are most likely preparing to remove them. Should we prepare to keep them instead?

Comment 10 Petr Viktorin 2019-10-16 15:55:58 UTC
Is everything on track for the mid-November deadline? Do you need any help?

Comment 11 Petr Viktorin 2019-11-01 17:53:48 UTC
Half a month until the deadline. Do you need more time? (If you do, let's get an exception soon!)
Is there somewhere progress can be tracked? Are there issues upstream, or in packaging?

Comment 12 Alex Perez 2019-11-04 18:41:55 UTC
The Sugar code base and most activities have now been ported to Python 3, and Sugar 0.116 (unstable release) was made back on September 4th[1]. We should probably get a stable release made between now and then, and then this needs to be packaged for Fedora, along with the new Sugar activities, all of which also needed to be ported to Sugar 0.116/Python 3.

[1] http://lists.sugarlabs.org/archive/sugar-devel/2019-September/057175.html

Comment 13 Petr Viktorin 2019-11-05 08:45:41 UTC
> We should probably get a stable release made between now and then

Which "then" is that?

It looks like Sugar won't make the November 15th deadline, and thus needs an exception. Is that right?
If so, we need to coordinate with maintainers of Sugar's dependencies, so they don't remove Python 2 support on November 15. There's about a week to do that. Is that what we need to do?

Comment 14 Peter Robinson 2019-11-08 07:30:57 UTC
FESCo ticket filed here: https://pagure.io/fesco/issue/2267

Comment 15 Adam Williamson 2019-11-27 18:08:45 UTC
sugar-toolkit depends on python2-simplejson and that went away already. This is prevent SoaS images building in Rawhide, e.g. https://koji.fedoraproject.org/koji/taskinfo?taskID=39373467 .

Comment 16 Peter Robinson 2020-01-26 09:32:13 UTC
Core Sugar shell/UX moved to py3.

Comment 17 Ibiam 2020-02-19 23:27:18 UTC
Can this be closed as Peter pointed out, Sugar has moved to python3.

Comment 18 Peter Robinson 2020-02-20 10:28:55 UTC
(In reply to Ibiam from comment #17)
> Can this be closed as Peter pointed out, Sugar has moved to python3.

We're using this one to track all of the sugar changes. You can see details here:
https://bugzilla.redhat.com/buglist.cgi?bug_id=1737929&bug_id_type=anddependson&format=tvp&list_id=10855354